=== levels/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

set(LEVELS_I18N_PATH ${CMAKE_CURRENT_SOURCE_DIR}/../levels-i18n/)

# Handle level headers' translations
file(GLOB levelheaders_po ${CMAKE_CURRENT_SOURCE_DIR}/*-po/)
foreach(levelheader_po ${levelheaders_po})
    string(REPLACE "-po" "" levelheader ${levelheader_po})
    get_filename_component(LEVEL_CODENAME ${levelheader} NAME)
    set(SCENEFILE "${LEVEL_CODENAME}*.txt")
    set(SCENEDEST)
    set(PODIR     "${LEVEL_CODENAME}-po/")
    set(HELPDIR)
    set(HELPDEST  "")
    message(STATUS "Manage translations for level headers '${LEVEL_CODENAME}*'")
    include(${LEVELS_I18N_PATH}/CMakeLists.txt)
endforeach(levelheader_po)

# Handle all levels' translations
file(GLOB levelcategories_paths ${CMAKE_CURRENT_SOURCE_DIR}/*/scene.txt)
foreach(levelcategory_path ${levelcategories_paths})
    string(REPLACE "//scene.txt" "" levelcategory ${levelcategory_path})
    get_filename_component(LEVEL_CODENAME ${levelcategory} NAME_WE)
    set(SCENEFILE "${LEVEL_CODENAME}/scene.txt")
    set(SCENEDEST "${LEVEL_CODENAME}.txt")
    set(PODIR     "${LEVEL_CODENAME}/po/")
    set(HELPDIR   "${LEVEL_CODENAME}/help/")
    set(HELPDEST  "")
    MESSAGE(STATUS "Managing translations for level '${LEVEL_CODENAME}'")
    include(${LEVELS_I18N_PATH}/CMakeLists.txt)
endforeach(levelcategory_path)
