=== debian/changelog ===
colobot (0.1.2-3build1) trusty; urgency=medium

  * No change rebuild against glew 1.10.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 02 Jan 2014 13:20:58 +0000

colobot (0.1.2-3) unstable; urgency=low

  * Try another patch to consider non-Linux GNU variants

 -- Didier Raboud <odyx@debian.org>  Fri, 29 Nov 2013 13:15:03 +0100

colobot (0.1.2-2) unstable; urgency=low

  * Add patch to let kFreeBSD and Hurd be considered Linuxes and
    therefore let the desktop files be installed

 -- Didier Raboud <odyx@debian.org>  Tue, 26 Nov 2013 12:32:45 +0100

colobot (0.1.2-1) unstable; urgency=low

  * New 0.1.2 upstream release
    - Add Russian translation of interface and levels
    - Replace x86 assembler "int $3" code with assert(0)
    - New levels translation infrastructure in -data
  * Add patch to hide the black squares bug

 -- Didier Raboud <odyx@debian.org>  Tue, 26 Nov 2013 09:25:48 +0100
