=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ \
		--buildsystem=cmake \
		--parallel \
		--dbg-package=colobot-dbg

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE:STRING="RelWithDebInfo" \
	                     -DINSTALL_DOCS:BOOL=True \
	                     -DOPENAL_SOUND:BOOL=True

override_dh_auto_build:
	dh_auto_build -a
	dh_auto_build -i -- doc
